--    Program: 		CAPPOIMP_POSITION_HIERARCHY_STRUCTURE.sql
--    Description:  Import PO POSITION HIERARCHY STRUCTURE information 
--    Revision:     1st     
--    Parameter: 	
--    Created By:   Kenny Leung
--    Date:         23-Jan-2006

set doc off;      
set verify off;
set serveroutput on size 1000000;
whenever sqlerror exit failure rollback;

declare   
   l_processed_count		number;
   l_rejected_count 		number;
   l_err_msg				varchar2(2000);
   l_err_msg_tmp			varchar2(2000);
   
   l_position_structure_id  number;
                    		                 		
   cursor cur_structures is
      select * 
      from   CRST_PER_POSITION_STRUCTURES
      for update;

begin
   l_processed_count := 0;
   l_rejected_count  := 0;
   l_err_msg := '';
   
   for cur in cur_structures loop   	
     l_err_msg_tmp := '';
     
     select PER_POSITION_STRUCTURES_S.NEXTVAL 
     into l_position_structure_id
     FROM DUAL;
     
     update CRST_PER_POSITION_STRUCTURES
     set    position_structure_id_n = l_position_structure_id
     where  position_structure_id = cur.POSITION_STRUCTURE_ID;
     
     UPDATE PER_POSITION_STRUCTURES
     SET NAME = CAPBRIMP_MAPPINGRenameStr(SUBSTR(NAME,1,4),NAME)
     WHERE POSITION_STRUCTURE_ID = CUR.POSITION_STRUCTURE_ID;
     
     begin
       -- import data
       insert into PER_POSITION_STRUCTURES
       (
          POSITION_STRUCTURE_ID   ,
          BUSINESS_GROUP_ID       ,
          NAME                    ,
          COMMENTS                ,
          PRIMARY_POSITION_FLAG   ,
          REQUEST_ID              ,
          PROGRAM_APPLICATION_ID  ,
          PROGRAM_ID              ,
          PROGRAM_UPDATE_DATE     ,
          ATTRIBUTE_CATEGORY      ,
          ATTRIBUTE1              ,
          ATTRIBUTE2              ,
          ATTRIBUTE3              ,
          ATTRIBUTE4              ,
          ATTRIBUTE5              ,
          ATTRIBUTE6              ,
          ATTRIBUTE7              ,
          ATTRIBUTE8              ,
          ATTRIBUTE9              ,
          ATTRIBUTE10             ,
          ATTRIBUTE11             ,
          ATTRIBUTE12             ,
          ATTRIBUTE13             ,
          ATTRIBUTE14             ,
          ATTRIBUTE15             ,
          ATTRIBUTE16             ,
          ATTRIBUTE17             ,
          ATTRIBUTE18             ,
          ATTRIBUTE19             ,
          ATTRIBUTE20             ,
          LAST_UPDATE_DATE        ,
          LAST_UPDATED_BY         ,
          LAST_UPDATE_LOGIN       ,
          CREATED_BY              ,
          CREATION_DATE           ,
          OBJECT_VERSION_NUMBER    
       )
       values
       (
            l_position_structure_id     ,
            CAPBRIMP_MAPPING.GetBGMapping(cur.BUSINESS_GROUP_ID),
            CAPBRIMP_MAPPING.RenameStr(Substr(cur.NAME,1,4),cur.NAME),
            cur.COMMENTS                ,
            cur.PRIMARY_POSITION_FLAG   ,
            cur.REQUEST_ID              ,
            cur.PROGRAM_APPLICATION_ID  ,
            cur.PROGRAM_ID              ,
            cur.PROGRAM_UPDATE_DATE     ,
            cur.ATTRIBUTE_CATEGORY      ,
            cur.ATTRIBUTE1              ,
            cur.ATTRIBUTE2              ,
            cur.ATTRIBUTE3              ,
            cur.ATTRIBUTE4              ,
            cur.ATTRIBUTE5              ,
            cur.ATTRIBUTE6              ,
            cur.ATTRIBUTE7              ,
            cur.ATTRIBUTE8              ,
            cur.ATTRIBUTE9              ,
            cur.ATTRIBUTE10             ,
            cur.ATTRIBUTE11             ,
            cur.ATTRIBUTE12             ,
            cur.ATTRIBUTE13             ,
            cur.ATTRIBUTE14             ,
            cur.ATTRIBUTE15             ,
            cur.ATTRIBUTE16             ,
            cur.ATTRIBUTE17             ,
            cur.ATTRIBUTE18             ,
            cur.ATTRIBUTE19             ,
            cur.ATTRIBUTE20             ,
            cur.LAST_UPDATE_DATE        ,
            CAPBRIMP_MAPPING.GetUserMapping(cur.LAST_UPDATED_BY),
            cur.LAST_UPDATE_LOGIN       ,
            CAPBRIMP_MAPPING.GetUserMapping(cur.CREATED_BY),
            cur.CREATION_DATE           ,
            cur.OBJECT_VERSION_NUMBER   
       );  
     exception
       when others then
     	 l_err_msg_tmp := sqlerrm;
     end;	  	    
     
     if l_err_msg_tmp IS NULL then
       l_processed_count := l_processed_count + 1;  
     else
       l_rejected_count := l_rejected_count + 1;
       l_err_msg := l_err_msg_tmp; 
     end if;
   end loop;

   if l_rejected_count = 0 then
   	 commit;
   else
     rollback;
   end if;
    
   -- insert into log table
   insert into capcnv_log ( prog_id,process_date, record_processed,record_rejected,record_extracted,err_msg) 
    values ('CAPPOIMP_POSITION_HIERARCHY_STRUCTURE', sysdate, l_processed_count, l_rejected_count, l_processed_count-l_rejected_count, l_err_msg );
   
   commit;
exception 
  when others then
    dbms_output.put_line(sqlerrm);
    rollback;  
end;
/


--exit
